'*******************************************************************************
'Programm for Display ILI9341 240x320 Pixel
'
'Bascom IDE 2.0.7.7
'
'    Version: V11
'    Date:22.05.2014
'    Email: Hkipnik@aol.com
'    Copyright (c) 2013 Hkipnik.  All rights reserved.
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
' Hardware: 2.2 TFT SPI 240x320
' http://www.elecfreaks.com/store/22-tft-lcd-tft0122sp-p-672.html
'*******************************************************************************
$nocompile

'*******************************************************************************
' Draw pic from SD Card with Bin File
' Bin File created with IMG2LCD Program
'*******************************************************************************
#if Sdcard = 1
Sub Lcd_pic_binsd(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word , Byval Width As Word , Byval Height As Word)
   Local Xend As Word , Yend As Word , Linelen As Word
   Local Zbv3 As Word
 '  Local Read_pos As Dword

   Linelen = 2 * Width
   Xend = Xpos + Width
   Yend = Ypos + Height
   Breit = Width
   Hoehe = Height
   Decr Xend
   Call Lcd_set_window(xpos , Ypos , Xend , Yend)
   Lcd_cs = 1
   Lcd_dc = 1
   Read_pos = 1
   Mmc_cs = 0
   Open Filename For Binary As #11

   !LDS     R30,       {Hoehe}                              'Anzahl lines
   !LDS     R31,       {Hoehe+1}
   Loop_2:
   !push    R30
   !push    R31

   Get #11 , Rgb_data(1) , , Linelen                        'Read_pos
   Mmc_cs = 1
   Lcd_cs = 0
   !LDS     R30,       {breit}                              'Anzahl breite
   !LDS     R31,       {breit+1}

   Loadadr Rgb_data(1) , X
   Loop_1:
   !LD R16, X+
   !LD R17, X+
   !OUT    spdr, R16
   Spi_read11:
   !sbis spsr, spif
   !rjmp spi_read11
   !OUT    spdr, R17
   Spi_read12:
   !sbis spsr, spif
   !rjmp spi_read12
   !SBIW  R30, 1                                            'decr breit
   !BRNE Loop_1
   '   Read_pos = Read_pos + Linelen
   !pop    R31
   !pop    R30
   !SBIW   R30, 1                                           'decr lines
   !BREq   End_1
   Mmc_cs = 0
   Lcd_cs = 1
   !Rjmp   Loop_2
   End_1:

   Close #11
   Set Mmc_cs
End Sub
#endif
'*******************************************************************************
' Draw Box x start -- y start -- width -- height -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
Sub Lcd_box(byval Xstart As Word , Byval Ystart As Word , Byval X_length As Word , Byval Y_height As Word , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)
   Local Xend As Word , Yend As Word
   Local Pixel As Dword , Zahl As Dword
   Xend = Xstart + X_length
   Yend = Ystart + Y_height
   Hoehe = X_length
   Breit = Y_height + Ystart
   If Fill = 1 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend)

      Rgb16 = Color
      Lcd_cs = 0
      Lcd_dc = 1

      !LDS     R30,       {Hoehe}                           'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows:
         !push    R30
         !push    R31
         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}
      Lo_line:
         Spiout Rgb16_high , 1
         Spiout Rgb16_low , 1
         !SBIW  R30, 1                                      'decr Pixel
         !BRNE Lo_line
         !pop    R31
         !pop    R30
         !SBIW   R30, 1                                     'decr hhe
         !BREq   End_ro
         !Rjmp   Lo_rows
      End_ro:

   Elseif Fill = 2 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend)

      Rgb16 = Color
      Lcd_cs = 0
      Lcd_dc = 1

      !LDS     R30,       {Hoehe}                           'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows1:
         !push    R30
         !push    R31
         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}
      Lo_line1:
         Spiout Rgb16_high , 1
         Spiout Rgb16_low , 1
         !SBIW  R30, 1                                      'decr Pixel
         !BRNE Lo_line1
         !pop    R31
         !pop    R30
         !SBIW   R30, 1                                     'decr hhe
         !BREq   End_ro1
         !Rjmp   Lo_rows1
      End_ro1:

      Call Lcd_line(xstart , Ystart , Xend , Ystart , 1 , Bordercolor)
      Call Lcd_line(xstart , Yend , Xend , Yend , 1 , Bordercolor)
      Call Lcd_line(xstart , Ystart , Xstart , Yend , 1 , Bordercolor)
      Call Lcd_line(xend , Ystart , Xend , Yend , 1 , Bordercolor)
   Elseif Fill = 3 Then
      Call Lcd_line(xstart , Ystart , Xend , Ystart , 1 , Bordercolor)
      Call Lcd_line(xstart , Yend , Xend , Yend , 1 , Bordercolor)
      Call Lcd_line(xstart , Ystart , Xstart , Yend , 1 , Bordercolor)
      Call Lcd_line(xend , Ystart , Xend , Yend , 1 , Bordercolor)
   End If
   Lcd_cs = 1
End Sub
'*******************************************************************************
' Lcd show BGC File  X Start  Y Start
' Important that you first RESTORE the image before calling this sub
'*******************************************************************************
Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)

   Local Ysize As Byte , Xsize As Byte
   Local Imagesize As Word
   Local L As Word , Pixel As Byte ,
   Local Pixelword As Word , Prevpixel As Word , Repeat As Byte
   Local X1size As Word , Y1size As Word , Yadd As Word , Tem As Word


   Read Ysize                                               'Read the first 4 bytes from the BGC, this contains info about the image
   Read Xsize
   Read Imagesize                                           'Byte 3&4 contains the image size

   X1size = Xsize
   Y1size = Ysize

   X1size = Xoffset + X1size
   Decr X1size
   Y1size = Y1size + Yoffset
   Call Lcd_set_window(xoffset , Yoffset , X1size , Y1size)


   Lcd_cs = 0
   Lcd_dc = 1
   Do
      Read Pixel                                            'Read the value for the pixel
      If Pixel = &HAA Then                                  'BGC file is rle coded &HAA represents this, the byte after &HAA is the number of times that the byte before &HAA wil be repeated
         Read Repeat                                        'Byte after &HAA contains the number of times to repeat
         Repeat = Repeat - 1
         For L = 1 To Repeat                                'Loop the repeat
            Rgb16 = Prevpixel
            Spiout Rgb16_high , 1
            Spiout Rgb16_low , 1
            Decr Imagesize                                  'Decrease the bytes still to be processed
         Next L                                             'Next repeat loop
      Else
         Rgb16 = 0
         If Pixel.0 = 1 Then Rgb16_low = Rgb16_low Or 10    'Blue
         If Pixel.1 = 1 Then Rgb16_low = Rgb16_low Or 21
         If Pixel.2 = 1 Then Rgb16 = Rgb16 Or 288           'Green
         If Pixel.3 = 1 Then Rgb16 = Rgb16 Or 576
         If Pixel.4 = 1 Then Rgb16 = Rgb16 Or 1152
         If Pixel.5 = 1 Then Rgb16_high = Rgb16_high Or 32  'Red
         If Pixel.6 = 1 Then Rgb16_high = Rgb16_high Or 72
         If Pixel.7 = 1 Then Rgb16_high = Rgb16_high Or 144
         Spiout Rgb16_high , 1
         Spiout Rgb16_low , 1

         Prevpixel = Rgb16                                  'Store the pixel in a temp word, maybe we need it if the next byte is &HAA
         Decr Imagesize
      End If
   Loop Until Imagesize = 0                                 'Do until all bytes are processed
   Lcd_cs = 1

End Sub
'*******************************************************************************
' Draw Text String  x y Start - Font Nr - Forecolor - Backcolor - Bold Nr 1 - 2 - 3 -4  1 is normal
' Beta Test
'*******************************************************************************
Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word , Byval Bold As Byte)

   Local Pzeichen As String * 1
   Local Zeichen_row As Word
   Local Ptemp As Word
   Local Ptemp2 As Word
   Local Px As Word
   Local Py As Word
   Local Char_rows As Byte
   Local Char_row_len As Byte
   Local Char_bytes As Byte
   Local Dummy As Byte
   Local String_pos As Byte
   Local Zeichen_code As Word
   Local Fcolh As Byte , Fcoll As Byte , Bacolh As Byte , Bacoll As Byte
   Local Doph As Word , Zbv As Byte
   Fcolh = High(forecolor)
   Fcoll = Low(forecolor)
   Bacolh = High(backcolor)
   Bacoll = Low(backcolor)

   Select Case Fontset
      Case 2:
         Char_rows = Lookup(0 , Font12x16)
         Char_row_len = Lookup(1 , Font12x16)
         Char_bytes = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)

      '(   Case 1:
         Char_rows = Lookup(0 , font3656)
         Char_row_len = Lookup(1 , font3656)
         Char_bytes = Lookup(2 , font3656)
         Dummy = Lookup(3 , font3656)

      Case 1:
         Char_rows = Lookup(0 , Font25x32)
         Char_row_len = Lookup(1 , Font25x32)
         Char_bytes = Lookup(2 , Font25x32)
         Dummy = Lookup(3 , Font25x32)

      Case 3:
         Char_rows = Lookup(0 , Crn20x24)
         Char_row_len = Lookup(1 , Crn20x24)
         Char_bytes = Lookup(2 , Crn20x24)
         Dummy = Lookup(3 , Crn20x24)
')
   End Select

   For String_pos = 1 To Len(lcd_text)                      'Fr jedes Zeichen im String
      Pzeichen = Mid(lcd_text , String_pos , 1)             'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32                     'Font files start with caracter 32
      Zeichen_code = Zeichen_code * Char_bytes

      Doph = Zeichen_code
      Doph = Doph + 4
      For Px = 1 To Char_bytes

         Select Case Fontset
            'Case 1 : Zeichenarray(px) = Lookup(doph , Font25x32)
            'Case 1 : Zeichenarray(px) = Lookup(doph , font3656)
            Case 2 : Zeichenarray(px) = Lookup(doph , Font12x16)
           ' Case 3 : Zeichenarray(px) = Lookup(doph , Crn20x24)
         End Select
         Incr Doph

      Next Px

      Py = Char_rows * 8
      Py = Py * Bold
      Py = Py + Lcd_posy

      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx

      Select Case Bold
         Case 1:
            Ptemp = Px + Char_row_len
         Case 2:
            Px = Px * Bold                                  '* 2
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 3:
            Px = Px * Bold                                  '* 3
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 4:
            Px = Px * Bold                                  '* 4
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
      End Select

      Decr Ptemp
      Call Lcd_set_window(px , Lcd_posy , Ptemp , Py)
      Lcd_cs = 0
      Lcd_dc = 1

      For Py = 1 To Char_rows
         Ptemp = Py - 1
         Ptemp = Ptemp * Char_row_len

         For Zeichen_row = 0 To 7
            For Doph = 1 To Bold
               For Px = 1 To Char_row_len
                  Ptemp2 = Ptemp + Px
                  If Zeichenarray(ptemp2).zeichen_row = 1 Then
                     For Zbv = 1 To Bold
                        Rgb16 = Forecolor
                        Spiout Rgb16_high , 1
                        Spiout Rgb16_low , 1
                     Next Zbv
                  Else
                     For Zbv = 1 To Bold
                        Rgb16 = Backcolor
                        Spiout Rgb16_high , 1
                        Spiout Rgb16_low , 1
                     Next Zbv
                  End If
               Next Px
            Next Doph
         Next Zeichen_row
      Next Py
   Next String_pos
   Lcd_cs = 1
End Sub
'*******************************************************************************
' draw Circle
'*******************************************************************************
Sub Lcd_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color As Word)
   Local X0 As Word , Y0 As Word , Error As Integer
   Local Xp As Word , Yp As Word , Xe As Word , Ye As Word

   Error = -radius
   Xp = Radius
   Yp = 0

   While Xp >= Yp
      X0 = X + Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)

      X0 = X + Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      Error = Error + Yp
      Incr Yp
      Error = Error + Yp

      If Error >= 0 Then
         Decr Xp
         Error = Error - Xp
         Error = Error - Xp
      End If
   Wend
End Sub
'-------------------------------------------------------------------------------
'LCD Fill Circle
'-------------------------------------------------------------------------------
Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)

   Local Xy_radius As Integer
   Local Zahly As Integer
   Local Zahlx As Integer

   Local Y1 As Integer
   Local X1 As Integer

   Local Y11 As Integer
   Local X11 As Integer
   Local Xy As Integer

   Local X2 As Word , Y2 As Word


   Xy_radius = Radius * Radius

   Y1 = -radius
   X1 = -radius
   Lcd_cs = 0
   For Zahly = Y1 To Radius
      Y11 = Zahly * Zahly
      For Zahlx = X1 To Radius
         X11 = Zahlx * Zahlx
         Xy = X11 + Y11
         If Xy <= Xy_radius Then

            X2 = X + Zahlx
            Y2 = Y + Zahly
            Call Lcd_set_pixel(x2 , Y2 , Color1)
         End If
      Next
   Next

End Sub

'*******************************************************************************
'Draw Line
'*******************************************************************************
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte
   Local Y_count As Word , X_count As Word

   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   Lcd_cs = 0
   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         For Pen_count = 1 To Pen_width
          Call Lcd_set_pixel(x_pos , Y , Color)
          Incr X_pos
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
          Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         For Pen_count = 1 To Pen_width
             Call Lcd_set_pixel(x , Y_pos , Color)
             Incr Y_pos
         Next Pen_count
         Incr Pos
      Next X
   End If

End Sub
'*******************************************************************************
'Set Pixel
'*******************************************************************************
Sub Lcd_set_pixel(byval X As Word , Byval Y As Word , Byval Color As Word)

   Rgb16 = X
   Lcd_cs = 0
   Lcd_dc = 0
      !LDI  R23, $2a
      !OUT    spdr, R23
   Spi_10:
      !sbis spsr, spif
      !rjmp spi_10
   Lcd_dc = 1
      !LDS     R30,       {rgb16}
      !LDS     R31,       {rgb16+1}
      !OUT    spdr, R31
   Spi_read0:
      !sbis spsr, spif
      !rjmp spi_read0
      !OUT    spdr, R30
   Spi_read2:
      !sbis spsr, spif
      !rjmp spi_read2
      !OUT    spdr, R31
   Spi_read3:
      !sbis spsr, spif
      !rjmp spi_read3
      !OUT    spdr, R30
   Spi_read4:
      !sbis spsr, spif
      !rjmp spi_read4

   Rgb16 = Y
   Lcd_dc = 0
      !LDI  R23, $2b
      !OUT    spdr, R23
   Spi_11:
      !sbis spsr, spif
      !rjmp spi_11
      Lcd_dc = 1
      !LDS     R30,       {rgb16}
      !LDS     R31,       {rgb16+1}
      !OUT    spdr, R31
   Spi_ready7:
      !sbis spsr, spif
      !rjmp spi_ready7
      !OUT    spdr, R30
   Spi_ready8:
      !sbis spsr, spif
      !rjmp spi_ready8
      !OUT    spdr, R31
   Spi_ready9:
      !sbis spsr, spif
      !rjmp spi_ready9
      !OUT    spdr, R30
   Spi_read8:
      !sbis spsr, spif
      !rjmp spi_read8

      Lcd_dc = 0
      !LDI  R23, $2c
      !OUT    spdr, R23
   Spi_12:
      !sbis spsr, spif
      !rjmp spi_12
      Rgb16 = Color
      Lcd_dc = 1
      !LDS     R23,       {Rgb16_high}
      !OUT    spdr, R23
   Spi_13:
      !sbis spsr, spif
      !rjmp spi_13
      !LDS     R23,       {Rgb16_low}
      !OUT    spdr, R23
   Spi_14:
      !sbis spsr, spif
      !rjmp spi_14
    Lcd_cs = 1
End Sub
'*******************************************************************************
'  Clear Display
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)

   #if Lcd_mode = 1
      Call Lcd_set_window(0 , 0 , 239 , 319)
   #else
      Call Lcd_set_window(0 , 0 , 319 , 239)
   #endif
   !LD     XL,     Y+0
   !LD     XH,     Y+1
   !LD     R31,    X+
   !LD     R30,    X
   Lcd_cs = 0
   Lcd_dc = 1
      !ldi  R16, $03                                        '76800
   Wgloop0:
      !ldi  R17, $A0
   Wgloop1:
      !ldi  R18, $A0
   Wgloop2:
      !OUT    spdr, R30
   Spi_ready1:
      !sbis spsr, spif
      !rjmp spi_ready1
      !OUT    spdr, R31
   Spi_ready:
      !sbis spsr, spif
      !rjmp spi_ready

      !dec  R18
      !brne WGLOOP2

      !dec  R17
      !brne WGLOOP1

      !dec  R16
      !brne WGLOOP0

      Lcd_cs = 1

End Sub
'*******************************************************************************
'  Set Windows
'*******************************************************************************
Sub Lcd_set_window(byval Xs As Word , Byval Ys As Word , Byval Xe As Word , Byval Ye As Word)
   Local Temp1 As Byte

   Call Lcd_write_command(&H2a)                             'column set x
   Temp1 = High(xs)
   Call Lcd_write_data(temp1)
   Temp1 = Low(xs)
   Call Lcd_write_data(temp1)                               'start
   Temp1 = High(xe)
   Call Lcd_write_data(temp1)
   Temp1 = Low(xe)
   Call Lcd_write_data(temp1)                               'end

   Call Lcd_write_command(&H2b)                             'Page Address Set  y
   Temp1 = High(ys)
   Call Lcd_write_data(temp1)
   Temp1 = Low(ys)
   Call Lcd_write_data(temp1)                               'Start
   Temp1 = High(ye)
   Call Lcd_write_data(temp1)
   Temp1 = Low(ye)
   Call Lcd_write_data(temp1)                               'end

   Call Lcd_write_command(&H2c)                             'write to ram
End Sub
'*******************************************************************************
' send Color Data
'*******************************************************************************
Sub Lcd_write_color(byval Color As Word)
   Local Coll As Byte , Colh As Byte
   Coll = Low(color)
   Colh = High(color)

   Lcd_cs = 0
   Lcd_dc = 1
   Spiout Colh , 1
   Spiout Coll , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
' send Command
'*******************************************************************************
Sub Lcd_write_command(byval Command As Byte)
   Lcd_cs = 0
   Lcd_dc = 0
   Spiout Command , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
'  send Data
'*******************************************************************************
Sub Lcd_write_data(byval Da_ta As Byte)
   Lcd_cs = 0
   Lcd_dc = 1
   Spiout Da_ta , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
' Init the display
'*******************************************************************************
Sub Lcd_init()

   Lcd_reset = 0
   Waitms 150
   Lcd_reset = 1
   Waitms 150


   Call Lcd_write_command(&Hcb)                             'Power control A
   Call Lcd_write_data(&H39)
   Call Lcd_write_data(&H2c)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H34)
   Call Lcd_write_data(&H02)

   Call Lcd_write_command(&Hcf)                             'Power control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&Hc1)                                '8b
   Call Lcd_write_data(&H30)

   Call Lcd_write_command(&He8)                             'Driver timing control A (
   Call Lcd_write_data(&H85)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H78)


   Call Lcd_write_command(&Hea)                             'Driver timing control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H00)


   Call Lcd_write_command(&Hed)                             'Power on sequence control
   Call Lcd_write_data(&H64)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H12)
   Call Lcd_write_data(&H81)

   Call Lcd_write_command(&Hf7)                             'Pump ratio control
   Call Lcd_write_data(&H20)

   Call Lcd_write_command(&Hc0)                             'Power control
   Call Lcd_write_data(&H23)

   Call Lcd_write_command(&Hc1)                             'Power control
   Call Lcd_write_data(&H10)

   Call Lcd_write_command(&Hc5)                             'VCM control
   Call Lcd_write_data(&H3e)
   Call Lcd_write_data(&H28)

   Call Lcd_write_command(&Hc7)                             'VCOM Control 2
   Call Lcd_write_data(&H86)
   #if Lcd_mode = 1
      Call Lcd_write_command(&H36)                          'Memory Access Control
      Call Lcd_write_data(&B0100_1000)                      '0100-1000
   #else
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1110_1000)
   #endif

   Call Lcd_write_command(&H3a)                             'COLMOD: Pixel Format Set
   Call Lcd_write_data(&H55)

   Call Lcd_write_command(&Hb1)                             'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H18)

   Call Lcd_write_command(&Hb6)                             'Display Function Control
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H82)
   Call Lcd_write_data(&H27)

   Call Lcd_write_command(&Hf2)                             '3Gamma Function Disable
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&H26)                             'Gamma curve selected
   Call Lcd_write_data(&H01)


   Call Lcd_write_command(&He0)                             'Set Gamma
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H2b)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H4e)
   Call Lcd_write_data(&Hf1)
   Call Lcd_write_data(&H37)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H10)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H09)
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&He1)                             'Set Gamma
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H14)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H11)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&Hc1)
   Call Lcd_write_data(&H48)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H36)
   Call Lcd_write_data(&H0f)


   Call Lcd_write_command(&H11)                             'Exit Sleep
   Waitms 150
   Call Lcd_write_command(&H29)                             'normal display on
   Waitms 150
End Sub